-- Author: Promedeus  
-- I will refactor this once most of the features are implemented, as I'm unsure of what people
-- will want. It's easier to prototype like this and then refactor to pretty code later 

require "Window"
require "ChatSystemLib"

local AutoGuildInviter = {}
 
function AutoGuildInviter:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 
	
	o.invited = {}
	o.tItems = {}
	
	o.current = "guild"
	
	o.admin = "0"
	
	o.commandLookup = {
		guild = {
			name = "/ginvite ",
			msg = "",
			command = function() return o.commandLookup.guild.name end
		},
		circle = {
			name = "/cinvite ",
			msg = "",
			circleNum = "c1",
			command = function() return o.commandLookup.circle.name .. ' ' .. o.commandLookup.circle.circleNum .. ' ' end
		}
	}
	
	o.iFirst = 1
	o.iLast = 0

    return o
end

function AutoGuildInviter:Init()
    Apollo.RegisterAddon(self, false, "", {})
end

function AutoGuildInviter:OnLoad()
	self.xmlDoc = XmlDoc.CreateFromFile("AutoGuildInviter.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

function AutoGuildInviter:OnSave(eType)
	if eType ~= GameLib.CodeEnumAddonSaveLevel.Character then
        return nil
    end

	persistentData = {
		invited = self.invited,
		guildMsg = self.commandLookup.guild.msg,
		circleMsg = self.commandLookup.circle.msg
	}	
	
	return persistentData
end

function AutoGuildInviter:OnRestore(eType, tData)
	self.invited = tData.invited
	self.commandLookup.guild.msg = tData.guildMsg
	self.commandLookup.circle.msg = tData.circleMsg
end

function AutoGuildInviter:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "AutoGuildInviterForm", nil, self)
		if self.wndMain == nil then
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
		
	    self.wndMain:Show(false, true)
	
		Apollo.RegisterSlashCommand("agi", "OnAutoGuildInviterOn", self)
		Apollo.RegisterEventHandler("WhoResponse", "OnWhoResponse", self)
		Apollo.RegisterEventHandler("ChatMessage", "OnChatMessage", self)
		
		self.timer = ApolloTimer.Create(0.6, true, "OnTimer", self)
	end
end

function AutoGuildInviter:OnAutoGuildInviterOn(s, args)
	splitArgs = args:split(" ")
	if splitArgs[1] == nil or splitArgs[1] == "" then
		splitArgs[1] = "guild"
	end
	
	if splitArgs[1] == "dev" and splitArgs[2] ~= nil then
		--count = table.getn(splitArgs)
		--for i = 2, count - 1, 1 do
		--	self = self[splitArgs[i]]
		--end
		--ChatSystemLib.PostOnChannel(2, "Changed " .. splitArgs[count - 1] .. " from \"" .. self .. "\" to \"" .. splitArgs[count] .. "\"")
		--self = splitArgs[count]
		self.admin = splitArgs[2]
	elseif splitArgs[2] == "set" then
		if splitArgs[3] == "msg" then
			msg = ""
			count = table.getn(splitArgs)
			for i = 4, count, 1 do
				msg = msg .. ' ' .. splitArgs[i]
			end
			self.commandLookup[splitArgs[1]].msg = msg
			ChatSystemLib.PostOnChannel(2, "Set " .. splitArgs[1] .. " msg to " .. msg)
		end
	elseif splitArgs[1] ~= nil then
		self.current = splitArgs[1]
		self.commandLookup.circle.circleNum = splitArgs[2]
		ChatSystemLib.Command("/who")
	end
end

function AutoGuildInviter:OnTimer()
	if not self:Empty() then
		playerName = self:Pop()
		ChatSystemLib.Command(self.commandLookup[self.current]:command() .. playerName)
	end
end

function AutoGuildInviter:OnChatMessage(channelCurrent, tMessage) 
	--tMessage has bAutoResponse, bGM, bSelf, strSender, strRealmName, nPresenceState, arMessageSegments, unitSource, bShowChatBubble, bCrossFaction, nReportId
	-- arMessageSegments is an array of tables.  Each table representsa part of the message + the formatting for that segment.
	-- This allows us to signal font (alien text for example) changes mid stream.
	-- local example = arMessageSegments[1] 
	-- example.strText is the text
	if channelCurrent:GetType() == 15 then
		text = tMessage.arMessageSegments[1].strText
		splitText = text:split(" ")
		if splitText[4] == "invited" then
			playerName = splitText[1]
			if self.commandLookup[self.current].msg ~= "" and self.commandLookup[self.current].msg ~= nil then
				msg = self.commandLookup[self.current].msg
				msg = msg:gsub("<player>", playerName)
				if self.admin ~= "1337" then
					msg = "[AutoGuildInviter] " .. msg
				end
				--ChatSystemLib.PostOnChannel(2, msg)
				ChatSystemLib.Command("/w " .. playerName .. " " .. msg)
			end
		end
	end
end

function AutoGuildInviter:OnWhoResponse(arResponse, eWhoResult)
	if eWhoResult == GameLib.CodeEnumWhoResult.OK or eWhoResult == GameLib.CodeEnumWhoResult.Partial then
		if arResponse == nil or #arResponse == 0 then
			ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System, Apollo.GetString("Who_NoResults"))
			return
		end
		
		for _, tWho in ipairs(arResponse) do
			-- each line in arResponse has strName, nLevel, eRaceId, eClassId, ePlayerPathType, nWorldZone, strRace, strClass, strZone, strPath, the last 4 can be nil
			--for k, v in pairs(tWho) do
			--	ChatSystemLib.PostOnChannel(2, v)
			--end
			--ChatSystemLib.PostOnChannel(2, tWho.strName .. " " .. tostring(self.invited[tWho.strName] == nil) .. " " .. tostring(not self.invited[tWho.strName]))
			if self.invited[tWho.strName] == nil or not self.invited[tWho.strName] then
				
				self:Push(tWho.strName)
				self.invited[tWho.strName] = true
				--ChatSystemLib.PostOnChannel(2, "Queued " .. tWho.strName)
			end 
		end
	elseif eWhoResult == GameLib.CodeEnumWhoResult.UnderCooldown then
		ChatSystemLib.PostOnChannel(ChatSystemLib.ChatChannel_System, Apollo.GetString("Who_UnderCooldown"), "")
	end
end

function AutoGuildInviter:OnOK()
	self.wndMain:Close() 
end

function AutoGuildInviter:OnCancel()
	self.wndMain:Close()
end


function AutoGuildInviter:Push( oValue )
    local iNewIndex = self.iLast + 1
	self.iLast = iNewIndex
	self.tItems[iNewIndex] = oValue
	return iNewIndex
end

function AutoGuildInviter:Pop()
	local iNewFront = self.iFirst
	if self:Empty() then
		return
	end
	
	local oValue = self.tItems[iNewFront]
	self.tItems[iNewFront] = nil
	self.iFirst = iNewFront + 1
	
	return oValue
end

function AutoGuildInviter:InsertAbsolute( iPos, item )
	if iPos < self.iFirst or iPos > self.iLast + 1 then
		return 0
	end
    table.insert( self.tItems, iPos, item )
	self.iLast = self.iLast + 1
	return iPos
end

function AutoGuildInviter:RemoveAbsolute( iPos )
	if iPos < self.iFirst or iPos > self.iLast then
		return 0
	end
    table.remove( self.tItems, iPos )
	self.iLast = self.iLast - 1
	return iPos
end

function AutoGuildInviter:Insert( iPos, item )
	return self:InsertAbsolute( self.iFirst + iPos - 1, item )
end

function AutoGuildInviter:Remove( iPos )
    return self:RemoveAbsolute( self.iFirst + iPos - 1, item )
end

function AutoGuildInviter:GetItems()
    return self.tItems
end

function AutoGuildInviter:GetSize()
    return self.iLast - self.iFirst + 1
end

function AutoGuildInviter:Empty()
	return self.iFirst > self.iLast
end

local AutoGuildInviterInst = AutoGuildInviter:new()
AutoGuildInviterInst:Init()

function string:split( inSplitPattern, outResults )

   if not outResults then
      outResults = { }
   end
   local theStart = 1
   local theSplitStart, theSplitEnd = string.find( self, inSplitPattern, theStart )
   while theSplitStart do
      table.insert( outResults, string.sub( self, theStart, theSplitStart-1 ) )
      theStart = theSplitEnd + 1
      theSplitStart, theSplitEnd = string.find( self, inSplitPattern, theStart )
   end
   table.insert( outResults, string.sub( self, theStart ) )
   return outResults
end


